/* Generated by Together */

package com.easy.pfol.service.abonnement.ejb;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import java.util.List;
import javax.jdo.PersistenceManager;
import com.easy.pfol.util.jdo.PersistenceManagerHelper;
import javax.jdo.Transaction;
import javax.jdo.Query;
import java.util.Collection;
import com.easy.pfol.business.jdo.Subscription;
import com.easy.pfol.business.jdo.SnsnSubsNetServNumber;
import com.easy.pfol.business.jdo.SubscriptionBars;
import com.easy.pfol.business.jdo.WebStructureClientAdmin;
import javax.jdo.JDOUserException;
import java.util.Date;
import java.util.Calendar;
import com.easy.pfol.util.jdo.AS400DateHelper;
import java.util.HashSet;
import com.easy.pfol.integration.dto.AbonnementDTO;
import java.util.Iterator;
import com.easy.util.NotImplementedException;
import java.util.ArrayList;

/**
 * @ejbHome <{com.easy.pfol.service.abonnement.ejb.AbonnementHome}>
 * @ejbRemote <{com.easy.pfol.service.abonnement.ejb.Abonnement}>
 * @ejbTransactionAttribute TX_SUPPORTS
 * @ejbTransactionType Bean
 * @author EASY
 * @version <tt> $Revision:1.0$ </tt>
 * @ejbJNDIname com/easy/pfol/service/abonnement/ejb/AbonnementHome
 */
public class AbonnementBean implements SessionBean {
    private SessionContext ctx;

    public void setSessionContext(SessionContext context) throws RemoteException {
        ctx = context;
    }

    public void ejbActivate() throws RemoteException {
    }

    public void ejbPassivate() throws RemoteException {
    }

    public void ejbRemove() throws RemoteException {
    }

    public void ejbCreate() throws CreateException, RemoteException {
        // Write your code here
    }

    public Collection rechercher(int numeroCompte, String login, boolean isAdmin) {
        try {
            PersistenceManager pm = PersistenceManagerHelper.getDisePersistenceManager();
            Transaction tx = pm.currentTransaction(); /// en l'absence de JCA
            Collection resultSnsnSIM;
            Collection resultSnsnGSM;
            Collection resultSub;
            Collection resultSubBars;
            Collection result = new HashSet();
            tx.begin();

            {
                //Chargement des objets de type SNSN SIM
                Query q = pm.newQuery(SnsnSubsNetServNumber.class);
                String filter = "carteSim.statutDeCarte == \"2\" &&  subscription.accountNo == numeroCompte && snsnTypeNumber == \"SC\"  &&"
                    + " snsnEffectiveDate <= dateDuJour && ( snsnExpirationDate == 0 || snsnExpirationDate >= dateDuJour )  ";
				//carteSim.statutDeCarte == \"2\" &&
                //q.declareVariables("CarteSim cs");
                q.declareParameters("int numeroCompte,int dateDuJour,String LIDOHINTS");
                q.setFilter(filter);
                long startTime = System.currentTimeMillis();
                q.setOrdering("subscriptionNumber ascending");
                resultSnsnSIM= new ArrayList ((Collection)q.execute(new Integer(numeroCompte), AS400DateHelper.toStorage(new Date()),"load=dfg"));
                long endTime = System.currentTimeMillis();
                System.err.println("Temps consomm subNetNumbers SIM :" + Long.toString(endTime - startTime) + " ms");
				q.closeAll();


				//Chargement des objets de type SNSN GSM
                 q = pm.newQuery(SnsnSubsNetServNumber.class);
                filter = "  subscription.accountNo == numeroCompte && ( snsnTypeNumber == \"HN\" || snsnTypeNumber == \"DT\" ) && "
                    + " snsnEffectiveDate <= dateDuJour && ( snsnExpirationDate == 0 || snsnExpirationDate >= dateDuJour )  ";
				//carteSim.statutDeCarte == \"2\" &&
                //q.declareVariables("CarteSim cs");
                q.declareParameters("int numeroCompte,int dateDuJour,String LIDOHINTS");
                q.setFilter(filter);
                startTime = System.currentTimeMillis();
                q.setOrdering("subscriptionNumber ascending");
                resultSnsnGSM = new ArrayList ( (Collection)q.execute(new Integer(numeroCompte), AS400DateHelper.toStorage(new Date()),"load=dfg") );
                endTime = System.currentTimeMillis();
                System.err.println("Temps consomm subNetNumbers GSM :" + Long.toString(endTime - startTime) + " ms");
				q.closeAll();


                //Chargement des objets de type Subscription
                q = pm.newQuery(Subscription.class);
                filter = "accountNo == numeroCompte";
                q.declareParameters("int numeroCompte,String LIDOHINTS");
                q.setFilter(filter);
                startTime = System.currentTimeMillis();
                resultSub =  (Collection)q.execute(new Integer(numeroCompte), "load=dfg") ;
                endTime = System.currentTimeMillis();
                System.err.println("Temps consomm subscription1:" + Long.toString(endTime - startTime) + " ms");
                System.err.flush();
                q.closeAll();
                pm.makeTransientAll(resultSub);

                //Chargement des obejts de type susbcription Bars
                q = pm.newQuery(SubscriptionBars.class);
                filter = "subscription.accountNo == numeroCompte && adminBar == \"1\" ";
                q.declareParameters("int numeroCompte,String LIDOHINTS");
                q.setFilter(filter);
                startTime = System.currentTimeMillis();
                resultSubBars = new ArrayList((Collection)q.execute(new Integer(numeroCompte), "load=oid"));
                endTime = System.currentTimeMillis();
                System.err.println("Temps consomm subBars:" + Long.toString(endTime - startTime) + " ms");
                System.err.flush();
                q.closeAll();
                
                }
            }
            tx.commit();
            pm.close();
            //Traitemnt sur base Admin
            pm = PersistenceManagerHelper.getAdminPersistenceManager();
            tx = pm.currentTransaction();
            Collection resultAdmin;
            tx.begin();
            {
                WebStructureClientAdmin wsca = null;
                Object oid = pm.newObjectIdInstance(WebStructureClientAdmin.class, login);
                long startTime = System.currentTimeMillis();
                try {
                    wsca = (WebStructureClientAdmin)pm.getObjectById(oid, true);
                    if (wsca != null)
                        System.err.println("Statut" + wsca.getStatut());
                }
                catch (JDOUserException e) {
                    System.err.println(login + "non trouv ");
                }
                long endTime = System.currentTimeMillis();
                System.err.println("Temps consomm admin:" + Long.toString(endTime - startTime) + " ms");
            }
            tx.commit();
            pm.close();
            return resultSub;
        }
        catch (Exception e) {
            e.printStackTrace();
        }
return null;
    }

    public Collection rechercherAvecSpeedo(int numeroCompte) {
        throw new NotImplementedException(); }
}
