/**
 * Speedo: an implementation of JDO compliant personality on top of JORM generic
 * I/O sub-system.
 * Copyright (C) 2001-2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Release: 0.1
 *
 * Contact: pascal.dechamboux@rd.francetelecom.com
 *
 * Authors: P. Dechamboux, Y. Devaux, F. Dhumeaux.
 *
 */

package org.objectweb.speedo.metadata;

/**
 * This class represents possible values for the attribute null-value of a field.
 * @author	Y. Devaux
 */
public abstract class SpeedoNullValue {
    public final static byte none = 0;
    public final static byte defaut = 1;
    public final static byte exception = 2;

    /**
     * Transoforms a String into a byte;
     * @param s the string to transform.
     * @return the byte corresponding to the String.
     */
    public static byte toByte(String s) {
        if (s.equals("exception"))
            return exception;
        else if (s.equals("default"))
            return defaut;
        else
            return none;
    } // end toByte
} // end SpeedoNullValue
