/**
 * Copyright (C) 2001-2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.speedo.runtime.dom;

import org.objectweb.perseus.persistence.lib.AbstractDirtyObjectManager;
import org.objectweb.perseus.persistence.api.PersistenceException;
import org.objectweb.perseus.cache.api.CacheEntry;
import org.objectweb.speedo.api.SpeedoAccessor;
import org.objectweb.speedo.api.LifeCycle;

public class SpeedoDirtyObjectManager extends AbstractDirtyObjectManager {

    public void makeDirty(CacheEntry cacheEntry) {
        SpeedoAccessor sa = (SpeedoAccessor) cacheEntry;
        sa.jdoChangeStatus(LifeCycle.ACTION_MAKEDIRTY);
    }

    public void makeClean(CacheEntry cacheEntry) {
        SpeedoAccessor sa = (SpeedoAccessor) cacheEntry;
        if (LifeCycle.isDirty(sa.jdoGetStatus())) {
            sa.jdoSetStatus(LifeCycle.PERSISTENT_CLEAN);
        }
    }

    public void flush(Object context, CacheEntry cacheEntry) throws PersistenceException {
        SpeedoAccessor sa = (SpeedoAccessor) cacheEntry;
        if (LifeCycle.isDirty(sa.jdoGetStatus())) {
            sm.write(context, sa.jdoGetSpeedoProxy().getPName(), sa);
        }
    }
}
