/**
 * copyright area
 */

package org.objectweb.speedo.runtime.genclass.collection;

import org.objectweb.speedo.api.SpeedoAccessor;

import java.util.Collection;
import java.util.HashSet;

import javax.jdo.spi.JDOImplHelper;

/**
 * @author	P. D?chamboux
 */
public class SetImpl extends CollectionImpl implements java.util.Set {

    static {
        JDOImplHelper.registerClass(
                SetImpl.class,
                new String[0],
                new Class[0],
                new byte[0],
                null,
                new SetImpl());
    }

    /**
     * Instanciates a new collection.
     */
    public SetImpl() {
        super();
    }

    /**
     * Instanciates and initializes a new collection with an initial size.
     */
    public SetImpl(int size) {
        super(size);
    }

    // ---------------------------------------------------------------------------
    // Overriden methods
    // ---------------------------------------------------------------------------

    protected Collection createCollection(int size) {
        return new HashSet(size);
    }

    protected CollectionImpl createInstance(int size) {
        return new SetImpl(size);
    }

    protected SpeedoAccessor createAccessor() {
        return new SetAccessor(this, collection.size());
    }
}
