/**
 * Copyright (C) 2001-2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.pobjects.basic;

import java.util.Date;
import java.util.Calendar;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class BasicA {

	public String f1 = null;
	public int f2 = 0;
    private int privateField = -1;
    protected int protectedField = -2;
    private Date d;
    private long l;


	private BasicA(String f1, int f2) {
		this.f1 = f1;
		this.f2 = f2;
        d = getTime();
        l = 1234567890L;
	}

	protected BasicA(String f1) {
		this.f1 = f1;
        d = getTime();
        l = 1234567890L;
	}
	public BasicA() {
        d = getTime();
        l = 1234567890L;
	}

    public Date getTime() {
        return new Date((Calendar.getInstance().getTime().getTime() / 1000) * 1000);
    }

	public String readF1() {
		return f1;
	}

	public void writeF1(String f1) {
		this.f1 = f1;
	}

	public int readF2() {
		return f2;
	}

	public void writeF2(int f2) {
		this.f2 = f2;
	}

	public String readF1_F2() {
		return f1 + f2;
	}

	public void writeF1() {
		f1 = "azerty";
	}

	public void writeF2() {
		f2 = 1;
	}

	public void writeF1_F2() {
		f1 = "qsdfgh";
		f2 = 2;
	}

	public void delegateWriteF1() {
		writeF1();
	}
}
