/***
 * Julia: France Telecom's implementation of the Fractal API
 * Copyright (C) 2001-2002 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: Eric.Bruneton@rd.francetelecom.com
 *
 * Author: Eric Bruneton
 */

package org.objectweb.speedo.pobjects.collection;

import java.util.Collection;
import java.util.Iterator;
import java.util.ArrayList;

public class Employee {

    public String name;

    public Employee boss;

    public Collection ints;

    public Collection friends;

    public Employee () {
    }

    public Employee (String name) {
        this.name = name;
        this.ints = new ArrayList();
        this.friends = new ArrayList();
    }

    public Employee (String name, Employee boss) {
        this.name = name;
        this.boss = boss;
        this.ints = new ArrayList();
        this.friends = new ArrayList();
    }

    public Iterator getInts () {
        return ints.iterator();
    }

    public void addInt (int i) {
        ints.add(new Integer(i));
    }

    public void removeInt (int i) {
        ints.remove(new Integer(i));
    }

    public Iterator getFriends () {
        return friends.iterator();
    }

    public void addFriend (Employee friend) {
        friends.add(friend);
    }

    public void removeFriend (Employee friend) {
        friends.remove(friend);
    }

    public String toString() {
        return name;
    }
}
