/**
 * Copyright (C) 2001-2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.pobjects.type;

import java.math.BigDecimal;
import java.math.BigInteger;

/**
 * This class contains the primitive type that Speedo must support:
 * boolean
 * byte
 * short
 * int
 * long
 * float
 * double
 * char
 * Boolean
 * Byte
 * Short
 * Integer
 * Long
 * Float
 * Double
 * Character
 * String
 * BigDecimal
 * BigInteger
 *
 * @author S.Chassande-Barrioz
 */
public class BasicType {
	public boolean pub_boolean_field;
	public byte pub_byte_field;
	public short pub_short_field;
	public int pub_int_field;
	public long pub_long_field;
	public float pub_float_field;
	public double pub_double_field;
	public char pub_char_field;

	public Boolean pub_oboolean_field;
	public Byte pub_obyte_field;
	public Short pub_oshort_field;
	public Integer pub_oint_field;
	public Long pub_olong_field;
	public Float pub_Float_field;
	public Double pub_Double_field;
	public Character pub_ochar_field;

	public String pub_string_field;

	public BigDecimal pub_bigdecimal_field;
	public BigInteger pub_biginteger_field;

	public boolean retrievePub_boolean_field() {
		return pub_boolean_field;
	}

	public void assignPub_boolean_field(boolean pub_boolean_field) {
		this.pub_boolean_field = pub_boolean_field;
	}

	public byte retrievePub_byte_field() {
		return pub_byte_field;
	}

	public void assignPub_byte_field(byte pub_byte_field) {
		this.pub_byte_field = pub_byte_field;
	}

	public short retrievePub_short_field() {
		return pub_short_field;
	}

	public void assignPub_short_field(short pub_short_field) {
		this.pub_short_field = pub_short_field;
	}

	public int retrievePub_int_field() {
		return pub_int_field;
	}

	public void assignPub_int_field(int pub_int_field) {
		this.pub_int_field = pub_int_field;
	}

	public long retrievePub_long_field() {
		return pub_long_field;
	}

	public void assignPub_long_field(long pub_long_field) {
		this.pub_long_field = pub_long_field;
	}

	public float retrievePub_float_field() {
		return pub_float_field;
	}

	public void assignPub_float_field(float pub_float_field) {
		this.pub_float_field = pub_float_field;
	}

	public double retrievePub_double_field() {
		return pub_double_field;
	}

	public void assignPub_double_field(double pub_double_field) {
		this.pub_double_field = pub_double_field;
	}

	public char retrievePub_char_field() {
		return pub_char_field;
	}

	public void assignPub_char_field(char pub_char_field) {
		this.pub_char_field = pub_char_field;
	}

	public Boolean retrievePub_oboolean_field() {
		return pub_oboolean_field;
	}

	public void assignPub_oboolean_field(Boolean pub_oboolean_field) {
		this.pub_oboolean_field = pub_oboolean_field;
	}

	public Byte retrievePub_obyte_field() {
		return pub_obyte_field;
	}

	public void assignPub_obyte_field(Byte pub_obyte_field) {
		this.pub_obyte_field = pub_obyte_field;
	}

	public Short retrievePub_oshort_field() {
		return pub_oshort_field;
	}

	public void assignPub_oshort_field(Short pub_oshort_field) {
		this.pub_oshort_field = pub_oshort_field;
	}

	public Integer retrievePub_oint_field() {
		return pub_oint_field;
	}

	public void assignPub_oint_field(Integer pub_oint_field) {
		this.pub_oint_field = pub_oint_field;
	}

	public Long retrievePub_olong_field() {
		return pub_olong_field;
	}

	public void assignPub_olong_field(Long pub_olong_field) {
		this.pub_olong_field = pub_olong_field;
	}

	public Float retrievePub_Float_field() {
		return pub_Float_field;
	}

	public void assignPub_Float_field(Float pub_Float_field) {
		this.pub_Float_field = pub_Float_field;
	}

	public Double retrievePub_Double_field() {
		return pub_Double_field;
	}

	public void assignPub_Double_field(Double pub_Double_field) {
		this.pub_Double_field = pub_Double_field;
	}

	public Character retrievePub_ochar_field() {
		return pub_ochar_field;
	}

	public void assignPub_ochar_field(Character pub_ochar_field) {
		this.pub_ochar_field = pub_ochar_field;
	}

	public String retrievePub_string_field() {
		return pub_string_field;
	}

	public void assignPub_string_field(String pub_string_field) {
		this.pub_string_field = pub_string_field;
	}

	public BigDecimal retrievePub_bigdecimal_field() {
		return pub_bigdecimal_field;
	}

	public void assignPub_bigdecimal_field(BigDecimal pub_bigdecimal_field) {
		this.pub_bigdecimal_field = pub_bigdecimal_field;
	}

	public BigInteger retrievePub_biginteger_field() {
		return pub_biginteger_field;
	}

	public void assignPub_biginteger_field(BigInteger pub_biginteger_field) {
		this.pub_biginteger_field = pub_biginteger_field;
	}
}
