package org.objectweb.speedo.runtime.query;

import org.objectweb.speedo.pobjects.ref.Department;
import org.objectweb.speedo.pobjects.ref.Employee;
import org.objectweb.speedo.SpeedoTestHelper;

import javax.jdo.PersistenceManager;

/**
 * Created by IntelliJ IDEA.
 * User: chassase
 * Date: 14 juin 2003
 * Time: 11:50:49
 * To change this template use Options | File Templates.
 */
public class POBuilder extends SpeedoTestHelper {

    public final static String depName = "RD";
    public final static String[] names = {"John", "Paul", "Marie", "Sandie"};
    public final static float[] salaries = {4000, 3000, 2999, 3001};
    public final static int[] nameOrder = {0, 2, 1, 3};
    public final static int[] salariesOrder = {0, 3, 1, 2};

    public POBuilder(String name) {
        super(name);
    }

    protected String getLoggerName() {
        return LOG_NAME + ".rt.query";
    }

    public void testCreationOfPersistentObject() {
        PersistenceManager pm = pmf.getPersistenceManager();
        Department d = new Department(depName);
        pm.makePersistent(d);
        for(int i=0; i<names.length; i++) {
            pm.makePersistent(new Employee(names[i], d, salaries[i]));
        }
        pm.close();
    }
}
