package org.objectweb.speedo.runtime.query;

import org.objectweb.speedo.SpeedoTestHelper;
import org.objectweb.speedo.api.ExceptionHelper;
import org.objectweb.speedo.pobjects.ref.Employee;
import org.objectweb.speedo.pobjects.ref.Department;
import org.objectweb.util.monolog.api.BasicLevel;

import javax.jdo.PersistenceManager;
import javax.jdo.Query;
import javax.jdo.JDOException;
import java.util.Collection;
import java.util.Iterator;

/**
 * Created by IntelliJ IDEA.
 * User: chassase
 * Date: 14 juin 2003
 * Time: 11:54:49
 * To change this template use Options | File Templates.
 */
public class PORemover extends SpeedoTestHelper {

    public PORemover(String name) {
        super(name);
    }

    protected String getLoggerName() {
        return LOG_NAME + ".rt.query";
    }

    public void testRemovingOfPersistentObject() {
        PersistenceManager pm = pmf.getPersistenceManager();
        try {
            Class empClass = Employee.class;
            Query query = pm.newQuery(empClass);
            Collection col = (Collection) query.execute();
            Iterator it = col.iterator();
            while(it.hasNext()) {
                Employee e = (Employee) it.next();
                assertNotNull("null Employee in the query result", e);
                pm.deletePersistent(e);
            }
            query.close(col);

            Class depClass = Department.class;
            query = pm.newQuery(depClass);
            col = (Collection) query.execute();
            it = col.iterator();
            while(it.hasNext()) {
                Department d = (Department) it.next();
                assertNotNull("null Department in the query result", d);
                pm.deletePersistent(d);
            }
            query.close(col);
        } catch (JDOException e) {
            Exception ie = ExceptionHelper.getNested(e);
            logger.log(BasicLevel.ERROR, "", ie);
            fail(ie.getMessage());
        } finally {
            pm.close();
        }
    }
}
