/**
 * Copyright (C) 2001-2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.runtime.ref;

import org.objectweb.speedo.SpeedoTestHelper;
import org.objectweb.speedo.pobjects.ref.Employee;
import org.objectweb.speedo.pobjects.ref.Department;

import javax.jdo.PersistenceManager;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class TestSimpleRef extends SpeedoTestHelper {

	public TestSimpleRef(String s) {
		super(s);
	}

	protected String getLoggerName() {
		return LOG_NAME + "rt.ref.SimpleRef";
	}
	public void test1() {
		String eName = "seb";
		String dName = "ASR";
		PersistenceManager pm = pmf.getPersistenceManager();
		Employee e = new Employee(eName, new Department(dName));
		pm.makePersistent(e);
		Object eId = pm.getObjectId(e);
		assertNotNull("null object identifier", eId);
		pm.close();

		e = null;
		pm = pmf.getPersistenceManager();
		e = (Employee) pm.getObjectById(eId, true);
		assertNotNull("null instance returned by getObjectById", e);
		assertEquals("Bad employee name", eName, e.name);
		assertNotNull("null instance returned by e.dept", e.dept);
		assertEquals("Bad department name", dName, e.dept.name);
		pm.deletePersistent(e.dept);
		pm.deletePersistent(e);
		pm.close();
	}

    public void testNullRef() {
        String eName = "nullRefEmp";
        PersistenceManager pm = pmf.getPersistenceManager();
        Employee e = new Employee(eName, null);
        pm.makePersistent(e);
        Object eId = pm.getObjectId(e);
        assertNotNull("null object identifier", eId);
        pm.close();

        e = null;
        pm = pmf.getPersistenceManager();
        e = (Employee) pm.getObjectById(eId, true);
        assertNotNull("null instance returned by getObjectById", e);
        assertEquals("Bad employee name", eName, e.name);
        assertNull("not null instance returned by e.dept", e.dept);
        pm.deletePersistent(e);
        pm.close();
    }
}
